

#include "mods.h"



void PaintMouseProc::PaintMap(HWND hWnd,IPoint2 m)
	{
ViewExp *vpt = ip->GetViewport(hWnd);
if (!vpt) return;

Ray ray, wray;
float at;
TimeValue t = ip->GetTime();	
Point3 norm, pt;
Interval valid;
BOOL changed = FALSE;	

	// Get mod contexts and nodes for this modifier
ModContextList mcList;
INodeTab nodeList;
ip->GetModContexts(mcList,nodeList);

	// Calculate a ray from the mouse point
int dist;
IPoint2 inc; 

dist = Length(m-mod->pp)/(int)mod->eradius +1;
inc = (m-mod->pp)/dist;

	
mod->pp = m;

Tab<Matrix3> obtm,iobtm;
Tab<Point3> xynorm,znorm,xynormlocal;
Tab<Ray> rray;
float pirad;

pirad = 3.14f/mod->eradius;


for (int i=0; i<nodeList.Count(); i++) {
	INode *node = nodeList[i];




// Back transform the ray into object space.		

	Matrix3 tobtm  = node->GetObjectTM(t);
	Matrix3 tiobtm = Inverse(tobtm);

	obtm.Append(1,&tobtm,1);
	iobtm.Append(1,&tiobtm,1);

//xynorm
	Matrix3 TM;
	vpt->GetAffineTM(TM);
	Matrix3 invTM = Inverse(TM);
	Point3 txynorm;
	txynorm.x = (float) inc.x;
	txynorm.y = -(float) inc.y;
	txynorm.z = 0.0f;
	txynorm = VectorTransform(invTM, txynorm);
	txynorm = VectorTransform(tiobtm,txynorm);
	txynorm = Normalize(txynorm)*mod->strength;
	xynorm.Append(1,&txynorm,1);
//move z
	Ray tempray;
	vpt->MapScreenToWorldRay(float(m.x), float(m.y),tempray);

	Ray tempray2;
	tempray2.dir = VectorTransform(tiobtm, tempray.dir);
	rray.Append(1,&tempray2,1);

	Point3 tznorm;
	tznorm = VectorTransform(tiobtm,tempray.dir);
	tznorm = -Normalize(tznorm)*mod->strength;
	znorm.Append(1,&tznorm,1);

	}




for (int j = 0;j < dist;j++)
	{
	vpt->MapScreenToWorldRay(float(m.x), float(m.y),wray);
	
	
	for (int i=0; i<nodeList.Count(); i++) {

		GeomObject *obj;

	// Get the object from the node
		INode *node = nodeList[i];

		ObjectState os = node->EvalWorldState(t);
		if (os.obj->SuperClassID()==GEOMOBJECT_CLASS_ID) {
			obj = (GeomObject*)os.obj;
		} else {
			continue;
			}


		ray.p   = iobtm[i] * wray.p;
		ray.dir = rray[i].dir;
	
		// See if we hit the object
		Point3 bary;
		DWORD faceIndex;

		BOOL hit = FALSE;


		Point3 hitPoint= vpt->MapScreenToView( m, 0.0f);
		float z;

		if (!mod->isMesh)
			hit = obj->IntersectRay(t,ray,at,norm);
		else 
			{
			hit = mod->meshSearchTree.HitMesh(hitPoint,z,faceIndex, norm);
			}

		if (hit) {


			if (mod->isMesh)
				{
				hitPoint.z = z;
				norm = mod->fnorms[faceIndex];
				pt = hitPoint * mod->meshSearchTree.invTm;
				mod->paintPoint = pt;
				mod->paintNorm = norm;//VectorTransform(mod->meshSearchTree.invTm,norm );

				}

			// Calculate the hit point
			else
				{
				pt = ray.p + ray.dir * at;
				mod->paintNorm = norm;
				mod->paintPoint = pt;
				}

			Point3 nnorm(0.0f,0.0f,0.0f);
//move normal
			if (mod->inkType == 0)
				nnorm = Normalize(norm)*mod->strength ;
//move xy
			else if (mod->inkType == 1)
				{
				nnorm = xynorm[i] ;
				}
//move z
			else if (mod->inkType == 2)
				{
				nnorm = znorm[i] ;

				}
//move x local
			else if (mod->inkType == 3)
				{
				nnorm.x = mod->strength  ;
				nnorm.y = 0.0f;
				nnorm.z = 0.0f;

				}
//move y local
			else if (mod->inkType == 3)
				{
				nnorm.y = mod->strength ;
				nnorm.x = 0.0f;
				nnorm.z = 0.0f;

				}
//move z local
			else if (mod->inkType == 4)
				{
				nnorm.z = mod->strength ;
				nnorm.x = 0.0f;
				nnorm.y = 0.0f;

				}
//smooth
			else if (mod->inkType == 5)
				{
				nnorm.z = 0.0f;
				nnorm.x = 0.0f;
				nnorm.y = 0.0f;

				}
//tesselate
			else if (mod->inkType == 6)
				{

				}
//select
			else if (mod->inkType == 7)
				{

				}

			
			float minx,maxx,miny,maxy,minz,maxz;
			minx = pt.x - mod->eradius; 
			miny = pt.y - mod->eradius;
			minz = pt.z - mod->eradius;

			maxx = pt.x + mod->eradius; 
			maxy = pt.y + mod->eradius;
			maxz = pt.z + mod->eradius;

			for (int vc = 0; vc < obj->NumPoints();vc++)

				{
//look bounding box
				Point3 p = obj->GetPoint(vc);
				if ( (p.x >= minx)  && (p.x <= maxx) &&
					 (p.y >= miny)  && (p.y <= maxy) && 
					 (p.z >= minz)  && (p.z <= maxz) ) 
					{
					float d = Length(pt-p);
					if (d <mod->eradius)
						{
						if (mod->inkType<6)
							{
							if (vc < mod->DeltaList.Count())
								{
								float f,f1;
								f = ((float)cos(d*pirad) + 1.0f)/2.0f;
								f1 = (1.0f-d/mod->eradius);
//DebugPrint("f %f f1 %f \n",f,f1);
								f = (f*(1.0f-mod->hardness))+ (f1*(mod->hardness));
						
//						mod->DeltaList[vc] += (nnorm * f);
//if addative check distance
								if (mod->SelectMode & MOUSE_ALT)
									mod->TempList[vc] -= (nnorm * f) * mod->fpressure;
								else mod->TempList[vc] += (nnorm * f) * mod->fpressure;
								if (!mod->Addative)
									{
									if (mod->SelectMode & MOUSE_ALT)
										{
										if (Length(mod->TempList[vc]) > mod->strengthsquared)
											mod->TempList[vc] = -Normalize(mod->TempList[vc]) * mod->strength;
										}
									else
										{
										if (Length(mod->TempList[vc]) > mod->strengthsquared)
											mod->TempList[vc] = Normalize(mod->TempList[vc]) * mod->strength;
										}
	
									}	


								changed = TRUE;
								}
							}
//select ink
						else if (mod->inkType ==7)
							{
							if (mod->SelectMode & MOUSE_ALT)
								{
								mod->SelectVertList[vc] = FALSE;
								changed = TRUE;
								}
							else 
								{
								mod->SelectVertList[vc] = TRUE;
								changed = TRUE;
								}
							

							}
						}
					}
				}
			break;
			}

		}
	m -= inc;
	}
nodeList.DisposeTemporary();
ip->ReleaseViewport(vpt);
if (changed)
	{

	if (mod->inkType<6)
		{
  
		mod->NotifyDependents(Interval(t,t), PART_GEOM, REFMSG_MOD_EVAL);
		}
	if (mod->inkType==7)
		{
		mod->NotifyDependents(Interval(t,t), PART_SELECT, REFMSG_MOD_EVAL);
		mod->NotifyDependents(Interval(t,t), PART_SUBSEL_TYPE, REFMSG_MOD_EVAL);
		mod->NotifyDependents(Interval(t,t), PART_DISPLAY, REFMSG_MOD_EVAL);
		}
	}

}


void PaintMouseProc::HitMap(HWND hWnd,IPoint2 m)
	{

ViewExp *vpt = ip->GetViewport(hWnd);
if (!vpt) 
	{
	return;
	}

Ray ray, wray;
float at;
TimeValue t = ip->GetTime();	
Point3 norm, pt;
Interval valid;
BOOL changed = FALSE;	

	// Get mod contexts and nodes for this modifier
ModContextList mcList;
INodeTab nodeList;
ip->GetModContexts(mcList,nodeList);

	// Calculate a ray from the mouse point
int dist;
IPoint2 inc; 

dist = Length(m-mod->pp)/(int)mod->eradius +1;
inc = (m-mod->pp)/dist;

	
mod->pp = m;

Tab<Matrix3> obtm,iobtm;
Tab<Point3> xynorm,znorm,xynormlocal;
Tab<Ray> rray;
float pirad;

pirad = 3.14f/mod->eradius;


for (int i=0; i<nodeList.Count(); i++) {
	INode *node = nodeList[i];




// Back transform the ray into object space.		

	Matrix3 tobtm  = node->GetObjectTM(t);
	Matrix3 tiobtm = Inverse(tobtm);

	obtm.Append(1,&tobtm,1);
	iobtm.Append(1,&tiobtm,1);

//xynorm
	Matrix3 TM;
	vpt->GetAffineTM(TM);
	Matrix3 invTM = Inverse(TM);
	Point3 txynorm;
	txynorm.x = (float) inc.x;
	txynorm.y = -(float) inc.y;
	txynorm.z = 0.0f;
	txynorm = VectorTransform(invTM, txynorm);
	txynorm = VectorTransform(tiobtm,txynorm);
	txynorm = Normalize(txynorm)*mod->strength;
	xynorm.Append(1,&txynorm,1);
//move z
	Ray tempray;
	vpt->MapScreenToWorldRay(float(m.x), float(m.y),tempray);

	Ray tempray2;
	tempray2.dir = VectorTransform(tiobtm, tempray.dir);
	rray.Append(1,&tempray2,1);

	Point3 tznorm;
	tznorm = VectorTransform(tiobtm,tempray.dir);
	tznorm = -Normalize(tznorm)*mod->strength;
	znorm.Append(1,&tznorm,1);

	}




//for (int j = 0;j < dist;j++)
	{
	vpt->MapScreenToWorldRay(float(m.x), float(m.y),wray);
	
	
	for (int i=0; i<nodeList.Count(); i++) {

		GeomObject *obj;

	// Get the object from the node
		INode *node = nodeList[i];
		if (!mod->isMesh)
			{
			ObjectState os = node->EvalWorldState(t);
			if (os.obj->SuperClassID()==GEOMOBJECT_CLASS_ID) {
				obj = (GeomObject*)os.obj;
			} else {
				continue;
				}
			}

		ray.p   = iobtm[i] * wray.p;
		ray.dir = rray[i].dir;
	
		// See if we hit the object
		BOOL hit = FALSE;
		DWORD faceIndex;
		Point3 bary;

		Point3 hitPoint= vpt->MapScreenToView( m, 0.0f);
		float z;
		if (mod->isMesh)
			{
//			hit = mod->msh.IntersectRay(ray, at, norm, faceIndex, bary);
			hit = mod->meshSearchTree.HitMesh(hitPoint,z,faceIndex, norm);
			if (hit)
				{
				hitPoint.z = z;
				mod->paintPoint = hitPoint * mod->meshSearchTree.invTm;
				mod->paintNorm = VectorTransform(mod->meshSearchTree.invTm,norm );
				mod->NotifyDependents(Interval(t,t), PART_DISPLAY, REFMSG_MOD_EVAL);
				mod->ip->RedrawViews(ip->GetTime(),REDRAW_INTERACTIVE);
				}
			}
		else 
			{
			hit = obj->IntersectRay(t,ray,at,norm);

			if (hit) {

			// Calculate the hit point
				pt = ray.p + ray.dir * at;

				mod->paintNorm = norm;
				mod->paintPoint = pt;
				mod->NotifyDependents(Interval(t,t), PART_DISPLAY, REFMSG_MOD_EVAL);
				mod->ip->RedrawViews(ip->GetTime(),REDRAW_INTERACTIVE);
				}
			}
		

		}
	}
nodeList.DisposeTemporary();
ip->ReleaseViewport(vpt);

}

void PaintMouseProc::MousePointDown(int point, int flags, IPoint2 m)
	{
	Point3 p(0.0f,0.0f,0.0f);
	mod->pp = m;
	for (int i = 0; i < mod->DeltaList.Count(); i++)
		{
		mod->TempList[i] = p;
		}
	mod->SelectMode = flags;
	if ((!(flags & MOUSE_ALT)) && (!(flags & MOUSE_CTRL)))
		{
		if (mod->inkType == 7)
			{
			for (i = 0; i < mod->SelectVertList.Count(); i++)
				{
				mod->SelectVertList[i] = FALSE;
				}
			}

		}
	ip->RedrawViews(ip->GetTime(),REDRAW_BEGIN);
	mod->strokeState = INSTROKE;
	mod->redoNormalList = FALSE;
	}

void PaintMouseProc::MousePointUp(int point, int flags, IPoint2 m)
	{
	Point3 p(0.0f,0.0f,0.0f);
	if (!theHold.Holding() ) 
		{
		theHold.Begin();
		}

	theHold.Put(new MoveRestore(mod));
	theHold.Accept(TSTR(_T("Paint Deform")));
				

	for (int i = 0; i < mod->DeltaList.Count(); i++)
		{
		mod->DeltaList[i] += mod->TempList[i];
		mod->TempList[i] = p;
		}

	ip->RedrawViews(ip->GetTime(),REDRAW_END);
	mod->strokeState = OUTOFSTROKE;
	mod->redoNormalList = TRUE;
	}


int PaintMouseProc::proc(
		HWND hWnd, int msg, int point, int flags, IPoint2 m)
	{
	int i;
	Point3 p(0.0f,0.0f,0.0f);
	static IPoint2 oldPoint;
	switch (msg) {
		case MOUSE_POINT:
			if (point==0) 
				{		
				MousePointDown(point, flags, m);
				} 
			else 
				{
//add hold here
				MousePointUp(point, flags, m);
				}
			break;

		case MOUSE_MOVE: {
		//	mod->fpressure = 1.0f;
			PaintMap(hWnd,m);
			ip->RedrawViews(ip->GetTime(),REDRAW_INTERACTIVE);			
			break;
			}

		case MOUSE_ABORT:
			for (i = 0; i < mod->DeltaList.Count(); i++)
				{
				mod->TempList[i] = p;
				}
			mod->NotifyDependents(Interval(ip->GetTime(),ip->GetTime()), PART_GEOM, REFMSG_MOD_EVAL);

			ip->RedrawViews(ip->GetTime(),REDRAW_END);
			break;

		case MOUSE_FREEMOVE:
			if (m!=oldPoint)
				{
				if (mod->strokeState == OUTOFSTROKE)
					{
					SetCursor(ip->GetSysCursor(SYSCUR_SELECT));
					HitMap(hWnd,m);
					}
				else if (mod->strokeState == STARTSTROKE) 
					{
					MousePointDown(0, flags, m);
					}
				else if (mod->strokeState == ENDSTROKE) 
					{
					MousePointUp(1, flags, m);
					}
				else if (mod->strokeState == INSTROKE) 
					{
					PaintMap(hWnd,m);
					}
				oldPoint = m;
				}
//			ip->RedrawViews(ip->GetTime(),REDRAW_INTERACTIVE);			
			break;
		}
	return TRUE;
	}

void PaintMode::EnterMode()
	{
	mod->EnterNormalAlign();	
	mod->inPaint = TRUE;
	mod->redoNormalList = TRUE;
	}

void PaintMode::ExitMode()
	{
	mod->ExitNormalAlign();	
	mod->inPaint = FALSE;
	}
